#include "GlobalState.h"

void error(string msg) {
    cout << "Error: " << msg << endl;
    exit(EXIT_FAILURE);
}

void zprava(string msg) {
    cout << msg << endl;
}

void smazat_roury() {
    string cmd1 = "rm -rf " + roura_A2B;
    string cmd2 = "rm -rf " + roura_B2A;
    string cmd3 = "rm -rf " + roura_B2C;
    string cmd4 = "rm -rf " + roura_C2A;

    system(cmd1.c_str());
    system(cmd2.c_str());
    system(cmd3.c_str());
    system(cmd4.c_str());
}

void vytvorit_roury() {
    smazat_roury();
    if (mkfifo(roura_A2B.c_str(), 0777) < 0) {
        error("Neslo vytvorit rouru A do B");
    }
    if (mkfifo(roura_B2A.c_str(), 0777) < 0) {
        error("Neslo vytvorit rouru B do A");
    }
    if (mkfifo(roura_B2C.c_str(), 0777) < 0) {
        error("Neslo vytvorit rouru B do C");
    }
    if (mkfifo(roura_C2A.c_str(), 0777) < 0) {
        error("Neslo vytvorit rouru C do A");
    }
}

/**
 * Toto bude rekneme simulovat nacitani konfigurace ze souboru :)
 */
void naplnit_struktury() {
    // C
    roura rCtmp;
    uzel uCtmp;
    uCtmp.name = "C";
    rCtmp.name = roura_B2C;
    rCtmp.mode = O_RDONLY;
    //rCtmp.owner = &uCtmp;
    uCtmp.r_pipes.push_back(rCtmp);
    rCtmp.name = roura_C2A;
    rCtmp.mode = O_WRONLY;
    uCtmp.w_pipes.push_back(rCtmp);
    uCtmp.penize = STARTOVNI_CASTKA;
    uCtmp.kill = 0;
    uzly.push_back(uCtmp);
    sum.push_back(0);
    // B
    roura rBtmp;
    uzel uBtmp;
    uBtmp.name = "B";
    rBtmp.name = roura_B2A;
    rBtmp.mode = O_WRONLY;
    uBtmp.w_pipes.push_back(rBtmp);
    rBtmp.name = roura_B2C;
    rBtmp.mode = O_WRONLY;
    uBtmp.w_pipes.push_back(rBtmp);
    rBtmp.name = roura_A2B;
    rBtmp.mode = O_RDONLY;
    uBtmp.r_pipes.push_back(rBtmp);
    uBtmp.penize = STARTOVNI_CASTKA;
    uBtmp.kill = 0;
    uzly.push_back(uBtmp);
    sum.push_back(0);
    // A
    roura rAtmp;
    uzel uAtmp;
    uAtmp.name = "A";
    rAtmp.name = roura_B2A;
    rAtmp.mode = O_RDONLY;
    uAtmp.r_pipes.push_back(rAtmp);
    rAtmp.name = roura_A2B;
    rAtmp.mode = O_WRONLY;
    uAtmp.w_pipes.push_back(rAtmp);
    rAtmp.name = roura_C2A;
    rAtmp.mode = O_RDONLY;
    uAtmp.r_pipes.push_back(rAtmp);
    uAtmp.penize = STARTOVNI_CASTKA;
    uAtmp.kill = 0;
    uzly.push_back(uAtmp);
    sum.push_back(0);

    cout << "Nastaveni:" << endl << "----------" << endl;
    for(int i = 0; i < uzly.size(); i++) {
        cout << "Uzel " << uzly[i].name << ":" << endl;
        for(int j = 0; j < uzly[i].r_pipes.size(); j++) {
            cout << "  r: " << uzly[i].r_pipes[j].name << endl;
        }
        for(int j = 0; j < uzly[i].w_pipes.size(); j++) {
            cout << "  w: " << uzly[i].w_pipes[j].name << endl;
        }
    }
}

void* reading(void* arg) {
    balik* me = (balik*) arg;
    while(1) {
        char* buffer = (char*) malloc(sizeof(char) * BUFFER_SIZE);
        read(me->b_roura->fd, buffer, BUFFER_SIZE);

        if(atoi(buffer) == 0) { // mame bud marker, nebo snapshot
            if(buffer[1] == 0) { // mame marker
                if(me->b_uzel->name != uzly[SNAPSHOTTER].name) { // ja NEposilam marker
                    for(int i = 0; i < me->b_uzel->w_pipes.size(); i++) { // poslem do vsech smeru marker
                        write(me->b_uzel->w_pipes[i].fd, buffer, BUFFER_SIZE);
                        cout << "* " << me->b_uzel->name << " preposila marker do " << me->b_uzel->w_pipes[i].name << endl;
                    }
                    sprintf(buffer, "%s:%d", me->b_uzel->name.c_str(), me->b_uzel->penize);
                    for(int i = 0; i < me->b_uzel->w_pipes.size(); i++) { // poslem do vsech smeru snapshot
                        write(me->b_uzel->w_pipes[i].fd, buffer, BUFFER_SIZE);
                        cout << "* " << me->b_uzel->name << " posila snapshot do " << me->b_uzel->w_pipes[i].name << endl;
                    }
                }
                me->b_uzel->kill = 1; // uz jsme POSLALI marker (i snapshot)
            } else { // mame snapshot
                if(me->b_uzel->name != uzly[SNAPSHOTTER].name) { // ja NEposilam marker
                    for(int i = 0; i < me->b_uzel->w_pipes.size(); i++) {
                        if(me->b_uzel->name.c_str()[0] != buffer[0]) { // snapshot ktery nam prisel, jsem NEposlal ja
                            write(me->b_uzel->w_pipes[i].fd, buffer, BUFFER_SIZE);
                            cout << "* " << me->b_uzel->name << " preposila snapshot do " << me->b_uzel->w_pipes[i].name << endl;
                        }
                    }
                } else { // ja posilam marker, takze si musim poznamenat finance
                    int k = buffer[0] - 65; // dirty hack
                    sum[k] = atoi(buffer+2); // dirty, dirty hack (preskocime nazev uzlu a delitko)
                    int skip = sum.size();
                    int suma = 0;
                    for(int i = 0; i < sum.size(); i++) {
                        if(sum[i] != 0) {
                            skip--;
                            suma += sum[i];
                        }
                    }

                    if(skip == 1) { // uz zbyvam jenom ja
                        suma += me->b_uzel->penize;
                        cout << "SNAPSHOT JE: " << suma << endl;
                    }
                }
            }
        } else { // prisly nam penize
            me->b_uzel->penize += atoi(buffer);
            me->b_uzel->kill = 0;
            cout << me->b_uzel->name << " ziskava: " << atoi(buffer) << "  nyni ma: " << me->b_uzel->penize << endl;
        }
    }
}

void* writting(void* arg) {
    balik* me = (balik*) arg;
    while(1) {
        char buffer[BUFFER_SIZE];
        int random = rand() % 10;
        if (random == 5) { // posleme nejake penize
            int sendMoney = (rand() % 10) + 1;
            sprintf(buffer, "%d", sendMoney);
            cout << me->b_uzel->name << " posila: " << buffer << " do: " << me->b_roura->name << endl;
            write(me->b_roura->fd, buffer, BUFFER_SIZE);
            //cout << "real" << me->b_roura->fd << endl;
            me->b_uzel->penize -= sendMoney;
        }
        sleep(1);
    }
}

void* marker_fnc(void* arg) {
    int i = SNAPSHOTTER;
    while(1) {
        sleep(SNAPSHOT_TIME);

        char buffer[BUFFER_SIZE];
        sprintf(buffer, "%s", uzly[i].name.c_str());
        cout << "Marker posila: " << uzly[i].name.c_str() << endl;
        for(int j = 0; j < uzly[i].w_pipes.size(); j++) {
            write(uzly[i].w_pipes[j].fd, buffer, BUFFER_SIZE);
            sum[i] = 0;
        }
    }
}

/**
 * Fuj, ale kvuli blokujicimu rezimu nevidim moc jinych moznosti
 */
void* spustit_vlakno_cteni(void* arg) {
    balik* b = (balik*) arg;
    pthread_t* tmp = (pthread_t*) malloc(sizeof(pthread_t));
    b->b_roura->thread = tmp;
    b->b_roura->fd = open(b->b_roura->name.c_str(), O_RDONLY);
    if ( pthread_create(tmp, NULL, reading, b) != 0 ) {
        error("pthread_create() error");
    }
}

/**
 * Fuj, ale kvuli blokujicimu rezimu nevidim moc jinych moznosti
 */
void* spustit_vlakno_zapis(void* arg) {
    balik* b = (balik*) arg;
    pthread_t* tmp = (pthread_t*) malloc(sizeof(pthread_t));
    b->b_roura->thread = tmp;
    b->b_roura->fd = open(b->b_roura->name.c_str(), O_WRONLY);
    //cout << b->b_roura->fd << endl;
    if ( pthread_create(tmp, NULL, writting, b) != 0 ) {
        error("pthread_create() error");
    }
}

/**
 * Uzly mame, otevreme tedy komunikacni kanaly
 */
void spustit_vlakna() {
    for(int i = 0; i < uzly.size(); i++) {
        for(int j = 0; j < uzly[i].r_pipes.size(); j++) {
            //cout << "open for r: " << uzly[i].r_pipes[j].name << endl;
            balik* tmp = (balik*) malloc(sizeof(balik));
            tmp->b_uzel = &uzly[i];
            tmp->b_roura = &uzly[i].r_pipes[j];
            pthread_t* pt = (pthread_t*) malloc(sizeof(pthread_t));
            if ( pthread_create(pt, NULL, spustit_vlakno_cteni, tmp) != 0 ) {
                error("pthread_create() error");
            }
        }
        for(int j = 0; j < uzly[i].w_pipes.size(); j++) {
            //cout << "open for w: " << uzly[i].w_pipes[j].name << endl;
            balik* tmp = (balik*) malloc(sizeof(balik));
            tmp->b_uzel = &uzly[i];
            tmp->b_roura = &uzly[i].w_pipes[j];
            pthread_t* pt = (pthread_t*) malloc(sizeof(pthread_t));
            if ( pthread_create(pt, NULL, spustit_vlakno_zapis, tmp) != 0 ) {
                error("pthread_create() error");
            }
        }
    }

    pthread_t marker;
    pthread_create(&marker, NULL, marker_fnc, NULL);
}

int main() {
    SNAPSHOTTER = 2;

    vytvorit_roury();

    naplnit_struktury();

    spustit_vlakna();


    cout << "Celkova castka: " << 3 * STARTOVNI_CASTKA << endl;

    while (1) {
        sleep(10);
    }

    smazat_roury();

    return 0;
}
